SystemOrganization addCategory: #'Xpf-CodeTalk'!
SystemOrganization addCategory: #'Xpf-CodeTalk-Commands'!
SystemOrganization addCategory: #'Xpf-CodeTalk-Core'!

!OBCmdMultiView methodsFor: '*xpf-codetalk' stamp: 'mt 2/13/2009 14:27'!
execute
	|viewType|
	viewType := OBChoiceRequest labels: #(Source Bytecode Decompile PrettyPrint Xpf).
	self styler: SHTextStylerST80 new.
	viewType ifNotNil: [self perform: (#toggle, viewType) asSymbol]! !

!OBCmdMultiView methodsFor: '*xpf-codetalk' stamp: 'cs 1/15/2009 17:24'!
styler: styler
	| panel morph |
	
	panel := requestor browser panels 
		detect: [ :each | each isKindOf: OBDefinitionPanel ]
		ifNone: [ ^ self ].
	morph := OBPluggableTextMorph allSubInstances
		detect: [ :each | each model == panel ]
		ifNone: [ ^ self ].
	morph styler: (styler
		view: morph;
		yourself).! !

!OBCmdMultiView methodsFor: '*xpf-codetalk' stamp: 'topa 2/13/2009 13:47'!
toggleXpf

	self styler: XpfTextStyler new.
	self setTextInDefinitionPanel: target source.! !

!String methodsFor: '*xpf-codetalk' stamp: 'topa 2/12/2009 21:34'!
findAllStrings: aString
	"Returns a collection with all starting indices of the given string in me."
	
	|indices currentStartIndex|
	indices := Bag new.
	currentStartIndex := 1.
	
	[currentStartIndex := (self findString: aString startingAt: currentStartIndex) + 1.
		currentStartIndex > 1 
	] whileTrue: [indices add: currentStartIndex - 1].

	^indices! !

!MCVersion methodsFor: '*xpf-codetalk-override' stamp: 'mt 3/24/2009 16:08'!
load

	self loadSourceText.
	MCVersionLoader loadVersion: self! !

!MCVersion methodsFor: '*xpf-codetalk' stamp: 'cs 3/25/2009 19:44'!
loadSourceText

	self snapshot definitions
		select: [:def | def isMethodDefinition]
		thenDo: [:def | def source: (def sourceText ifNil: [def source])].! !

!MCVersion methodsFor: '*xpf-codetalk-override' stamp: 'mt 3/24/2009 16:09'!
merge

	self loadSourceText.
	MCVersionMerger mergeVersion: self! !

!DataStream methodsFor: '*xpf-codetalk' stamp: 'mt 3/24/2009 15:43'!
references

    ^ Dictionary new! !

!Text methodsFor: '*xpf-codetalk' stamp: 'mt 2/5/2009 17:42'!
removeAttributeOfKind: attClass from: start to: stop 
	"Removes an attribute kind over the interval start to stop."
	runs :=  runs copyReplaceFrom: start to: stop
			with: ((runs copyFrom: start to: stop)
				mapValues:
				[:attributes | attributes reject: [:each | each isKindOf: attClass]])! !

OBTextMorphEditorWithShout subclass: #XpfEditor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Core'!

!XpfEditor class methodsFor: 'as yet unclassified' stamp: 'mt 2/5/2009 17:36'!
initializeCmdKeyShortcuts
	super initializeCmdKeyShortcuts.
	CmdActions
		at: ($q asInteger + 1) put: #markAsGood:;
		at: ($r asInteger + 1) put: #markAsBad:;
		at: ($t asInteger + 1) put: #markAsUnclear:;
		at: ($w asInteger + 1) put: #removeMarkup:.
	
! !

!XpfEditor methodsFor: 'as yet unclassified' stamp: 'mt 1/23/2009 14:43'!
markAsBad: aCharacterStream
	paragraph setBackgroundForSelectionWith: Color red.
	self userHasEdited.
	^ true

	
! !

!XpfEditor methodsFor: 'as yet unclassified' stamp: 'mt 1/23/2009 14:44'!
markAsGood: aCharacterStream
	paragraph setBackgroundForSelectionWith: Color green.
	self userHasEdited.
	^ true
	
! !

!XpfEditor methodsFor: 'as yet unclassified' stamp: 'mfp 2/3/2009 16:17'!
markAsUnclear: aCharacterStream
	paragraph setBackgroundForSelectionWith: Color lightGray.
	self userHasEdited.
	^ true
	
! !

!XpfEditor methodsFor: 'as yet unclassified' stamp: 'mt 2/5/2009 17:36'!
removeMarkup: aCharacterStream
	paragraph removeBackgroundForSelection.
	self userHasEdited.
	^ true

	
! !

Object subclass: #XpfCodeTalk
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Core'!

!XpfCodeTalk class methodsFor: 'as yet unclassified' stamp: 'mt 3/24/2009 16:13'!
initialize

	super initialize.
	MCMethodDefinition addInstVarName: #sourceText.! !

SHTextStylerST80 subclass: #XpfTextStyler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Core'!

!XpfTextStyler methodsFor: 'private' stamp: 'topa 2/13/2009 14:09'!
privateStyle: aText
	"First, backup current style information about background color in text runs. Then let Shout work. Then restore background color information for text runs."

	| backupRuns |
	backupRuns := aText runs.

	super privateStyle: aText.
	
	backupRuns withStartStopAndValueDo: [:start :stop :attrs | |a|
		a := attrs detect: [:attr | attr isKindOf: XpfTextBackgroundColor] ifNone: [nil].
		a ifNotNil: [aText addAttribute: a from: start to: stop].
	]! !

!XpfTextStyler methodsFor: 'as yet unclassified' stamp: 'cs 3/18/2009 15:27'!
unstyledTextFrom: aText

	| backupRuns result |
	backupRuns := aText runs.

	result := super unstyledTextFrom: aText.
	
	backupRuns withStartStopAndValueDo: [:start :stop :attrs | |a|
		a := attrs detect: [:attr | attr isKindOf: XpfTextBackgroundColor] ifNone: [nil].
		a ifNotNil: [result addAttribute: a from: start to: stop]].
	^ result! !

!OBCodeBrowser methodsFor: '*xpf-codetalk-commands' stamp: 'topa 2/13/2009 13:41'!
cmdMarkAsBad
	^ XpfMarkBadCommand! !

!OBCodeBrowser methodsFor: '*xpf-codetalk-commands' stamp: 'topa 2/13/2009 13:41'!
cmdMarkAsGood
	^ XpfMarkGoodCommand! !

!OBCodeBrowser methodsFor: '*xpf-codetalk-commands' stamp: 'topa 2/13/2009 13:41'!
cmdMarkAsUnclear
	^ XpfMarkUnclearCommand! !

!OBCodeBrowser methodsFor: '*xpf-codetalk-commands' stamp: 'topa 2/13/2009 13:43'!
cmdRemoveMarkup
	^ XpfRemoveMarkupCommand! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 2/5/2009 18:08'!
markBadIcon
	^ Icons
			at: #'markBad'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self markBadIconContents readStream) ].! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 2/5/2009 18:06'!
markBadIconContents
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAACxSURBVDjL7dItC8JQAIXh491H
WbDvD1pEDIIKm1zDxqKi0WIULAZFYc1msF3ErEZlMC9Mhxx/gTAR28KpDxx4QRK/DCXwAbDg
0oLMTShtQF0F5AlwvwHkqy+Zxxs+lwsmvs8DKrIw8DCh8njNLOxRtxrU4yF3MFRhIBFQ2XxG
3W7yXq8xjULGsIsDFwF58zzq0YBpFPDc6XIKp/iFI4S7h5BbWGoFW03gyABVtyzxT8Ab8Xze
i+tkcykAAAAASUVORK5CYII='! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 2/5/2009 18:08'!
markGoodIcon
	^ Icons
			at: #'markGood'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self markGoodIconContents readStream) ].! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 2/5/2009 18:06'!
markGoodIconContents
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAC5SURBVDjLY/j//z8DJZhh1ADs
BjjsspIC4gb77ZZX7TdbXLVda9Zgs8xEihQDGmZfm/7/0KOD/3ff3/V/6plJ/y3mGjYQbYD9
NsurBx4e+D/10tT/nWc6/i+5sui/+RS9q0QbYLfB/OrWO1v+d5/p+t96qvn/3Auz/pt0aRNv
gPVyk4appyf+X3xl4f/ZF2b+n3Co579+mSrxXrCcZyhlMV2/wbRP56pRq+ZV3SLlBq1EOanR
lEgjAwAXIuIDq5qm/AAAAABJRU5ErkJggg=='! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 2/5/2009 18:08'!
markUnknownIcon
	^ Icons
			at: #'markUnknown'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self markUnknownIconContents readStream) ].! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 2/5/2009 18:07'!
markUnknownIconContents
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAQAAAC1+jfqAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAABlSURBVCjPY/jPgB8yDC4FilKK
DfJXZa6KNwhKYVfQkPW/63/b/+T/XA1YFchd7fqf/j/2f+N/5qtYFUhe7fif9D/sf91/BuwK
hBoS/jcBpcP/M2C3gluKrYHhKhA2MEgN2pDEDgEb0f5zlvXgVgAAAABJRU5ErkJggg=='! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 2/5/2009 18:08'!
removeMarkupIcon
	^ Icons
			at: #'removeMarkup'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self removeMarkupIconContents readStream) ].! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 2/5/2009 18:07'!
removeMarkupIconContents
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAQAAAC1+jfqAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAABbSURBVCjPzdAxDoAgEERRzsFp
95JbGI2ASA2SCOX3Ahtr8tuXTDIO959bCxRfpOitWS5vA+lMJg9JbKCTTmMQ1QS3ThqVQbBB
lsbgpXLYE8lHCXrqLptf9km7Dzv+FwGTaznIAAAAAElFTkSuQmCC'! !

!OBPluggableTextMorphWithShout class methodsFor: '*xpf-codetalk' stamp: 'mt 1/26/2009 14:54'!
on: anObject text: getTextSel accept: setTextSel readSelection: getSelectionSel menu: getMenuSel
	|styler answer stylerClass |
	answer := self new.
	stylerClass := answer stylerClass.
	styler := stylerClass
		ifNotNil:[
			stylerClass new
				view: answer;
				yourself].
	^ answer
		styler: styler;
		on: anObject
		text: getTextSel
		accept: setTextSel
		readSelection: getSelectionSel
		menu: getMenuSel! !

!OBPluggableTextMorphWithShout methodsFor: '*xpf-codetalk' stamp: 'topa 2/13/2009 13:48'!
stylerClass
	^XpfTextStyler! !

!OBPluggableTextMorphWithShout methodsFor: '*xpf-codetalk' stamp: 'topa 2/13/2009 13:48'!
textMorphClass
	"Answer the class used to create the receiver's textMorph"
	^XpfTextMorph! !

OBTextMorphWithShout subclass: #XpfTextMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Core'!

!XpfTextMorph methodsFor: 'private' stamp: 'topa 2/13/2009 14:09'!
editorClass
	"Answer the class used to create the receiver's editor"
	
	^XpfEditor! !

!MCStWriter methodsFor: '*xpf-codetalk-override' stamp: 'mt 4/17/2009 09:42'!
writeMethodSource: definition
	"CodeTalk stores text in the source and not a string. Convert this here."

	stream nextChunkPut: definition source asString.! !

!RunArray class methodsFor: '*xpf-codetalk' stamp: 'topa 2/13/2009 13:50'!
scanFrom: strm
	"Read the style section of a fileOut or sources file.  nextChunk has already been done.  We need to return a RunArray of TextAttributes of various kinds.  These are written by the implementors of writeScanOn:"
	| rr vv aa this |
	(strm peekFor: $( ) ifFalse: [^ nil].
	rr := OrderedCollection new.
	[strm skipSeparators.
	 strm peekFor: $)] whileFalse: 
		[rr add: (Number readFrom: strm)].
	vv := OrderedCollection new.	"Value array"
	aa := OrderedCollection new.	"Attributes list"
	[(this := strm next) == nil] whileFalse: [
		this == $, ifTrue: [vv add: aa asArray.  aa := OrderedCollection new].
		this == $a ifTrue: [aa add: 
			(TextAlignment new alignment: (Integer readFrom: strm))].
		this == $f ifTrue: [aa add: 
			(TextFontChange new fontNumber: (Integer readFrom: strm))].
		this == $F ifTrue: [aa add: (TextFontReference toFont: 
			(StrikeFont familyName: (strm upTo: $#) size: (Integer readFrom: strm)))].
		this == $b ifTrue: [aa add: (TextEmphasis bold)].
		this == $i ifTrue: [aa add: (TextEmphasis italic)].
		this == $u ifTrue: [aa add: (TextEmphasis underlined)].
		this == $= ifTrue: [aa add: (TextEmphasis struckOut)].
		this == $n ifTrue: [aa add: (TextEmphasis normal)].
		this == $- ifTrue: [aa add: (TextKern kern: -1)].
		this == $+ ifTrue: [aa add: (TextKern kern: 1)].
		this == $c ifTrue: [aa add: (TextColor scanFrom: strm)]. "color"
		this == $h ifTrue: [aa add: (XpfTextBackgroundColor scanFrom: strm)]. "background color - CodeTalk"
		this == $L ifTrue: [aa add: (TextLink scanFrom: strm)].	"L not look like 1"
		this == $R ifTrue: [aa add: (TextURL scanFrom: strm)].
				"R capitalized so it can follow a number"
		this == $q ifTrue: [aa add: (TextSqkPageLink scanFrom: strm)].
		this == $p ifTrue: [aa add: (TextSqkProjectLink scanFrom: strm)].
		this == $P ifTrue: [aa add: (TextPrintIt scanFrom: strm)].
		this == $d ifTrue: [aa add: (TextDoIt scanFrom: strm)].
		"space, cr do nothing"
		].
	aa size > 0 ifTrue: [vv add: aa asArray].
	^ self runs: rr asArray values: vv asArray
"
RunArray scanFrom: (ReadStream on: '(14 50 312)f1,f1b,f1LInteger +;i')
"! !

!MCMethodDefinition methodsFor: '*xpf-codetalk-override' stamp: 'mt 4/17/2009 09:50'!
= aDefinition
	"CodeTalk stores text in the source not a string. Convert this here."

	^(super = aDefinition)
		and: [aDefinition source asString = self source asString]
		and: [aDefinition category = self category]
		and: [aDefinition timeStamp = self timeStamp]! !

!MCMethodDefinition methodsFor: '*xpf-codetalk' stamp: 'mt 3/24/2009 16:07'!
provisions

	self saveSourceText.
	^ super provisions! !

!MCMethodDefinition methodsFor: '*xpf-codetalk' stamp: 'cs 3/25/2009 19:43'!
saveSourceText

	| class |
	self sourceText ifNotNil: [^ self].
	
 	class := Smalltalk at: self className asSymbol ifAbsent: [^ self].
	class := self classIsMeta
		ifTrue: [class class]
		ifFalse: [class].
	(class methodDict includesKey: self selector) ifFalse:[^self].
	self sourceText: (MethodReference
		class: class
		selector: self selector asSymbol) sourceCode.! !

!MCMethodDefinition methodsFor: '*xpf-codetalk' stamp: 'mt 3/24/2009 15:55'!
source: aStringOrText

	source := aStringOrText.! !

!MCMethodDefinition methodsFor: '*xpf-codetalk' stamp: 'mt 3/24/2009 15:52'!
sourceText

	^ sourceText! !

!MCMethodDefinition methodsFor: '*xpf-codetalk' stamp: 'mt 3/24/2009 15:52'!
sourceText: aText

	sourceText := aText.! !

!MultiNewParagraph methodsFor: '*xpf-codetalk' stamp: 'mt 1/22/2009 16:27'!
displayOn: aCanvas using: displayScanner at: somePosition 
	"Send all visible lines to the displayScanner for display"
	| visibleRectangle offset leftInRun line |
	visibleRectangle := aCanvas clipRect.
	offset := somePosition - positionWhenComposed.
	leftInRun := 0.
	(self lineIndexForPoint: visibleRectangle topLeft) 
		to: (self lineIndexForPoint: visibleRectangle bottomRight)
		do: 
			[ :i | 
			line := lines at: i.
			self
				drawBackgroundOn: aCanvas
					at: line;
				displaySelectionInLine: line
					on: aCanvas.
			line first <= line last ifTrue: 
				[ leftInRun := displayScanner 
					displayLine: line
					offset: offset
					leftInRun: leftInRun ] ]! !

!MultiNewParagraph methodsFor: '*xpf-codetalk' stamp: 'topa 2/13/2009 13:46'!
drawBackgroundOn: aCanvas at: line 
	| cb1 cb2 textLine bgAttr |
	textLine := self text 
		copyFrom: line first
		to: line last.
	textLine runs withStartStopAndValueDo: 
		[ :start :stop :attributes | 
		bgAttr := attributes 
			detect: [ :each | each isMemberOf: XpfTextBackgroundColor ]
			ifNone: [  ].
		bgAttr ifNotNil: 
			[ cb1 := self characterBlockForIndex: start + (line first - 1).
			cb2 := self characterBlockForIndex: stop + (line first - 1).
			aCanvas 
				fillRectangle: (cb1 left @ line top corner: cb2 right @ line bottom)
				color: bgAttr color ] ]! !

!MultiNewParagraph methodsFor: '*xpf-codetalk' stamp: 'topa 2/13/2009 13:46'!
removeBackgroundForSelection
	selectionStart stringIndex == selectionStop ifTrue: [^nil].
	self text removeAttributeOfKind: XpfTextBackgroundColor from: selectionStart stringIndex to: selectionStop stringIndex - 1! !

!MultiNewParagraph methodsFor: '*xpf-codetalk' stamp: 'topa 2/13/2009 13:46'!
setBackgroundForSelectionWith: aColor
	selectionStart stringIndex == selectionStop ifTrue: [^nil].
	self text addAttribute: (XpfTextBackgroundColor new color: aColor; yourself) from: selectionStart stringIndex to: selectionStop stringIndex - 1! !

OBCommand subclass: #XpfCodeMarkCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Commands'!

!XpfCodeMarkCommand class methodsFor: 'testing' stamp: 'cs 1/27/2009 17:30'!
takesText
	^ true! !

!XpfCodeMarkCommand methodsFor: 'as yet unclassified' stamp: 'mfp 2/3/2009 16:13'!
execute
	"'inspired' by ORCmdPrettyPrint>>execute"
	| panel morph editor |
	
	panel := requestor browser panels 
		detect: [ :each | each isKindOf: OBDefinitionPanel ]
		ifNone: [ ^ self ].
	morph := OBPluggableTextMorph allSubInstances
		detect: [ :each | each model == panel ]
		ifNone: [ ^ self ].
	editor := morph textMorph editor.
	self mark: target in: editor.
	morph hasUnacceptedEdits: true! !

!XpfCodeMarkCommand methodsFor: 'accessing' stamp: 'cs 1/27/2009 17:31'!
group
	^ #general! !

!XpfCodeMarkCommand methodsFor: 'testing' stamp: 'cs 1/27/2009 17:31'!
isActive
	^ target isKindOf: OBTextSelection! !

!XpfCodeMarkCommand methodsFor: 'as yet unclassified' stamp: 'mfp 2/3/2009 16:14'!
mark: aTarget in: anEditor
	^ self subclassResponsibility! !

XpfCodeMarkCommand subclass: #XpfMarkBadCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Commands'!

!XpfMarkBadCommand methodsFor: 'accessing' stamp: 'mt 2/5/2009 18:09'!
icon
	^#markBadIcon! !

!XpfMarkBadCommand methodsFor: 'accessing' stamp: 'mfp 2/3/2009 16:12'!
keystroke
	^ $B! !

!XpfMarkBadCommand methodsFor: 'accessing' stamp: 'mfp 2/3/2009 16:11'!
label
	^ 'mark bad'! !

!XpfMarkBadCommand methodsFor: 'editor-bridge' stamp: 'mfp 2/3/2009 16:15'!
mark: aTarget in: anEditor
	anEditor markAsBad: aTarget.! !

XpfCodeMarkCommand subclass: #XpfMarkGoodCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Commands'!

!XpfMarkGoodCommand methodsFor: 'accessing' stamp: 'cs 3/18/2009 15:27'!
icon

	^ #markGoodIcon! !

!XpfMarkGoodCommand methodsFor: 'accessing' stamp: 'mfp 2/3/2009 16:20'!
keystroke
	^ $G! !

!XpfMarkGoodCommand methodsFor: 'accessing' stamp: 'mfp 2/3/2009 16:20'!
label
	^ 'mark good'! !

!XpfMarkGoodCommand methodsFor: 'editor-bridge' stamp: 'mfp 2/3/2009 16:20'!
mark: aTarget in: anEditor
	anEditor markAsGood: aTarget.! !

XpfCodeMarkCommand subclass: #XpfMarkUnclearCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Commands'!

!XpfMarkUnclearCommand methodsFor: 'accessing' stamp: 'cs 3/18/2009 15:27'!
icon

	^ #markUnknownIcon! !

!XpfMarkUnclearCommand methodsFor: 'accessing' stamp: 'mfp 2/3/2009 16:24'!
keystroke
	^ $U! !

!XpfMarkUnclearCommand methodsFor: 'accessing' stamp: 'mfp 2/3/2009 16:24'!
label
	^ 'mark unclear'! !

!XpfMarkUnclearCommand methodsFor: 'editor-bridge' stamp: 'mfp 2/3/2009 16:25'!
mark: aTarget in: anEditor
	anEditor markAsUnclear: aTarget.! !

XpfCodeMarkCommand subclass: #XpfRemoveMarkupCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Commands'!

!XpfRemoveMarkupCommand methodsFor: 'as yet unclassified' stamp: 'cs 3/18/2009 15:27'!
icon

	^ #removeMarkupIcon! !

!XpfRemoveMarkupCommand methodsFor: 'as yet unclassified' stamp: 'mt 2/5/2009 17:46'!
label
	^'remove markup'! !

!XpfRemoveMarkupCommand methodsFor: 'as yet unclassified' stamp: 'mt 2/5/2009 17:44'!
mark: aTarget in: anEditor
	anEditor removeMarkup: aTarget.! !

TextAttribute subclass: #XpfTextBackgroundColor
	instanceVariableNames: 'color'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Core'!

!XpfTextBackgroundColor class methodsFor: 'instance creation' stamp: 'mt 1/26/2009 09:31'!
color: aColor
	^ self new color: aColor! !

!XpfTextBackgroundColor class methodsFor: 'instance creation' stamp: 'mt 1/26/2009 09:42'!
scanFrom: strm
	"read a color in the funny format used by Text styles on files. c125000255 or cblue;"

	| r g b |
	strm peek isDigit
		ifTrue:
			[r := (strm next: 3) asNumber.
			g := (strm next: 3) asNumber.
			b := (strm next: 3) asNumber.
			^ self color: (Color r: r g: g b: b range: 255)].
	"A name of a color"
	^ self color: (Color perform: (strm upTo: $;) asSymbol)! !

!XpfTextBackgroundColor methodsFor: 'comparing' stamp: 'mt 1/22/2009 11:23'!
= other 
	^ (other class == self class) 
		and: [other color = color]! !

!XpfTextBackgroundColor methodsFor: 'html' stamp: 'mt 1/22/2009 11:24'!
closeHtmlOn: aStream 
	"put on the given stream the tag to close the html  
	representation of the receiver"
	aStream nextPutAll: '</span>'! !

!XpfTextBackgroundColor methodsFor: 'accessing' stamp: 'mt 1/22/2009 11:22'!
color
	^ color! !

!XpfTextBackgroundColor methodsFor: 'accessing' stamp: 'mt 1/22/2009 17:51'!
color: aColor
	color := aColor copy alpha: 0.4.! !

!XpfTextBackgroundColor methodsFor: 'scanning' stamp: 'mt 1/22/2009 11:26'!
dominates: other
	^ other class == self class! !

!XpfTextBackgroundColor methodsFor: 'comparing' stamp: 'mt 1/22/2009 11:23'!
hash
	^ color hash! !

!XpfTextBackgroundColor methodsFor: 'html' stamp: 'mt 1/22/2009 11:25'!
openHtmlOn: aStream 
	"put on the given stream the tag to open the html  
	representation of the receiver"
	aStream nextPutAll: '<span style="background-color: #' , color printHtmlString , '">'! !

!XpfTextBackgroundColor methodsFor: 'printing' stamp: 'mt 1/22/2009 11:25'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' code: '; print: color! !

!XpfTextBackgroundColor methodsFor: 'scanning' stamp: 'mt 1/22/2009 11:27'!
writeScanOn: strm
	"Two formats.  c125000255 or cblue;"

	| nn str |
	strm nextPut: $h. "h ... highlight"
	(nn := color name) ifNotNil: [
		(self class respondsTo: nn) ifTrue: [
			^ strm nextPutAll: nn; nextPut: $;]].
	(Array with: color red with: color green with: color blue) do: [:float |
		str := '000', (float * 255) asInteger printString.
		strm nextPutAll: (str copyFrom: str size-2 to: str size)]! !
XpfCodeTalk initialize!
